package code;

import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpsExchange;

public class ObtainToken implements HttpHandler{

	private KeyCloak kcs;

	public ObtainToken(KeyCloak kcs) {
		this.kcs = kcs;
	}

	@Override
    public void handle(HttpExchange ex) throws IOException {
        HttpsExchange exchange = (HttpsExchange) ex;
        URI requestURI = exchange.getRequestURI();
        String stringURI = requestURI.toString();
        boolean wantsRedirectPage = Helper.isSameString(stringURI,URI.create("/").toString());
        boolean wantsToken = Helper.isSameString(stringURI,URI.create("/secured").toString());

        if(!wantsRedirectPage && !wantsToken) {
            Helper.pageNotFound(exchange);
            return;
        }

        String requestMethod = exchange.getRequestMethod();
        if (!Helper.isSameString(requestMethod, "GET")) {
            Helper.methodNotAllowed(exchange);
            return;
        }
        // get the html page
        String response = null;
        if(wantsRedirectPage)
        response = Helper.getPageContents("redirect.html");
        else if(wantsToken)
        response = Helper.getPageContents("domains.html");

        if(response == null || Helper.isSameString(response, "fail")){
            Helper.serverError(exchange);
            return;
        }
        response = response.replace("$DOMAIN", kcs.authServer())
        .replace("$REALM", kcs.realm())
        .replace("$MY_REDIRECT_URI", kcs.redirectUri());

        List<String> strlist = new ArrayList<>();
        strlist.add("text/html");
        exchange.getResponseHeaders().put("content-type", strlist);
        Helper.sendResponseOk(response, exchange);

//        	if(wantsToken) {
        		// NON FUNZIONA PERCHE' LA
//        		String[] arr = stringURI.split("/secured");
//        		for(int i=0; i<arr.length; i++)
//        			System.out.println(arr[i]);
//        		System.out.println("lunghezza = "+arr.length);
//
//        		String allParamsString = stringURI.split("/secured")[1];
//        		System.out.println("allParamsString = "+allParamsString);
//        		String[] allParamsArray = allParamsString.split("&");
//        		String state = allParamsArray[0];
//        		if(!this.state.equals(state)) {
//        			Helper.badRequest(exchange);
//        			return;
//        		}
//        		String authCode = allParamsArray[2];
//
//        		// request token
//        		String httpsURL = "http://"+kcs.authServer()+"/realms/"+kcs.realm()+"/protocol/openid-connect/token";
//        		URL myUrl = new URL(httpsURL);
////                SSLUtilities.trustAllHttpsCertificates();
////                SSLUtilities.trustAllHostnames();
//                HttpsURLConnection conn = (HttpsURLConnection)myUrl.openConnection();
//
//                conn.setReadTimeout(7000);
//                conn.setConnectTimeout(7000);
//                conn.setRequestMethod("POST");
//                conn.setDoOutput(true);
//                conn.setDoInput(true);
//
//                conn.setRequestProperty("content-type", "application/x-www-form-urlencoded");
//
//                String body = "grant_type=authorization_code"
//                		+ "&client_id="+kcs.clientId()
//                		+ "&code_verifier="+codeVerifier
//                		+ "&code="+authCode
//                		+ "&redirect_uri=https://localhost:3000/secured";
//                OutputStream outputStream = conn.getOutputStream();
//                outputStream.write(body.getBytes("UTF-8"));
//                outputStream.close();
//
//                String inputLine;
//                InputStream is = conn.getInputStream();
//                InputStreamReader isr = new InputStreamReader(is);
//                BufferedReader br = new BufferedReader(isr);
//                String response = "";
//                while ((inputLine = br.readLine()) != null) {
//                	response += inputLine;
//                }
//
//                br.close();
//                System.out.println(response);
//        	String answer = response.replace(remoteHOST,localHOST);

//        	}
    }








//
//    private String createRandomString() {
//    	SecureRandom sr = new SecureRandom();
//    	byte[] code = new byte[32];
//    	sr.nextBytes(code);
//    	return java.util.Base64.getUrlEncoder().withoutPadding().encodeToString(code);
//    }
//
//
//    private String createCodeChallenge(String verifier) throws UnsupportedEncodingException, NoSuchAlgorithmException {
//    	byte[] bytes = verifier.getBytes("US-ASCII");
//    	MessageDigest md = MessageDigest.getInstance("SHA-256");
//    	md.update(bytes, 0, bytes.length);
//    	byte[] digest = md.digest();
//    	return Base64.encodeBase64URLSafeString(digest);
//	}

}